Index: src/SymTab/Validate.cc
===================================================================
--- src/SymTab/Validate.cc	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/SymTab/Validate.cc	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -10,6 +10,6 @@
 // Created On       : Sun May 17 21:50:04 2015
 // Last Modified By : Rob Schluntz
-// Last Modified On : Mon Jul 13 14:38:19 2015
-// Update Count     : 184
+// Last Modified On : Wed Jul 22 13:16:00 2015
+// Update Count     : 194
 //
 
@@ -169,5 +169,5 @@
 		virtual TypeDecl *mutate( TypeDecl *typeDecl );
 		virtual DeclarationWithType *mutate( FunctionDecl *funcDecl );
-		virtual ObjectDecl *mutate( ObjectDecl *objDecl );
+		virtual DeclarationWithType *mutate( ObjectDecl *objDecl );
 		virtual CompoundStmt *mutate( CompoundStmt *compoundStmt );
 		virtual Type *mutate( TypeInstType *aggregateUseType );
@@ -203,6 +203,8 @@
 	void validateType( Type *type, const Indexer *indexer ) {
 		Pass1 pass1;
+		Pass2 pass2( false, indexer );
 		Pass3 pass3( indexer );
 		type->accept( pass1 );
+		type->accept( pass2 );
 		type->accept( pass3 );
 	}
@@ -403,4 +405,9 @@
 			} // for
 		} // for
+
+		if ( ctx->get_parameters().size() != contextInst->get_parameters().size() ) {
+			throw SemanticError( "incorrect number of context parameters: ", contextInst );
+		} // if
+
 		applySubstitution( ctx->get_parameters().begin(), ctx->get_parameters().end(), contextInst->get_parameters().begin(), ctx->get_members().begin(), ctx->get_members().end(), back_inserter( contextInst->get_members() ) );
 	}
@@ -534,4 +541,6 @@
 		init->get_args().push_back( new NameExpr( "0" ) );
 		Statement *initStmt = new ExprStmt( noLabels, init );
+		std::list<Statement *> initList;
+		initList.push_back( initStmt );
   
 		UntypedExpr *cond = new UntypedExpr( new NameExpr( "?<?" ) );
@@ -559,5 +568,5 @@
 		assignExpr->get_args().push_back( srcIndex );
   
-		*out++ = new ForStmt( noLabels, initStmt, cond, inc, new ExprStmt( noLabels, assignExpr ) );
+		*out++ = new ForStmt( noLabels, initList, cond, inc, new ExprStmt( noLabels, assignExpr ) );
 	}
 
@@ -612,5 +621,5 @@
 			delete assigns.front();
 			assigns.pop_front();
-		}
+		} // for
 
 		declsToAdd.insert( declsToAdd.begin(), assigns.begin(), assigns.end() );
@@ -827,5 +836,5 @@
 				rtt->get_parameters().clear();
 				cloneAll(typeInst->get_parameters(), rtt->get_parameters());
-			}
+			} // if
 			delete typeInst;
 			return ret;
@@ -881,7 +890,12 @@
 	}
 
-	ObjectDecl *EliminateTypedef::mutate( ObjectDecl * objDecl ) {
+	DeclarationWithType *EliminateTypedef::mutate( ObjectDecl * objDecl ) {
 		TypedefMap oldNames = typedefNames;
-		ObjectDecl *ret = Mutator::mutate( objDecl );
+		DeclarationWithType *ret = Mutator::mutate( objDecl );
+		if ( FunctionType *funtype = dynamic_cast<FunctionType *>( ret->get_type() ) ) {
+			return new FunctionDecl( ret->get_name(), ret->get_storageClass(), ret->get_linkage(), funtype, 0, ret->get_isInline(), ret->get_isNoreturn() );
+		} else if ( objDecl->get_isInline() || objDecl->get_isNoreturn() ) {
+			throw SemanticError( "invalid inline or _Noreturn specification in declaration of ", objDecl );
+		} // if
 		typedefNames = oldNames;
 		return ret;
Index: src/SynTree/Declaration.cc
===================================================================
--- src/SynTree/Declaration.cc	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/SynTree/Declaration.cc	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -10,6 +10,6 @@
 // Created On       : Mon May 18 07:44:20 2015
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Sat Jun 13 08:07:20 2015
-// Update Count     : 9
+// Last Modified On : Mon Jul 13 17:58:38 2015
+// Update Count     : 10
 //
 
@@ -27,9 +27,9 @@
 
 Declaration::Declaration( const std::string &name, DeclarationNode::StorageClass sc, LinkageSpec::Type linkage )
-		: name( name ), storageClass( sc ), linkage( linkage ), uniqueId( 0 ) {
+		: name( name ), storageClass( sc ), linkage( linkage ), isInline( false ), isNoreturn( false ), uniqueId( 0 ) {
 }
 
 Declaration::Declaration( const Declaration &other )
-		: name( other.name ), storageClass( other.storageClass ), linkage( other.linkage ), uniqueId( other.uniqueId ) {
+	: name( other.name ), storageClass( other.storageClass ), linkage( other.linkage ), isInline( other.isInline ), isNoreturn( other.isNoreturn ), uniqueId( other.uniqueId ) {
 }
 
Index: src/SynTree/Declaration.h
===================================================================
--- src/SynTree/Declaration.h	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/SynTree/Declaration.h	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -10,6 +10,6 @@
 // Created On       : Mon May 18 07:44:20 2015
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Sat Jun 13 09:10:31 2015
-// Update Count     : 25
+// Last Modified On : Mon Jul 13 18:15:59 2015
+// Update Count     : 28
 //
 
@@ -35,4 +35,8 @@
 	LinkageSpec::Type get_linkage() const { return linkage; }
 	void set_linkage( LinkageSpec::Type newValue ) { linkage = newValue; }
+	bool get_isInline() const { return isInline; }
+	void set_isInline( bool newValue ) { isInline = newValue; }
+	bool get_isNoreturn() const { return isNoreturn; }
+	void set_isNoreturn( bool newValue ) { isNoreturn = newValue; }
 	UniqueId get_uniqueId() const { return uniqueId; }
 
@@ -50,4 +54,5 @@
 	DeclarationNode::StorageClass storageClass;
 	LinkageSpec::Type linkage;
+	bool isInline, isNoreturn;
 	UniqueId uniqueId;
 };
@@ -75,5 +80,5 @@
 	typedef DeclarationWithType Parent;
   public:
-	ObjectDecl( const std::string &name, DeclarationNode::StorageClass sc, LinkageSpec::Type linkage, Expression *bitfieldWidth, Type *type, Initializer *init );
+	ObjectDecl( const std::string &name, DeclarationNode::StorageClass sc, LinkageSpec::Type linkage, Expression *bitfieldWidth, Type *type, Initializer *init, bool isInline = false, bool isNoreturn = false );
 	ObjectDecl( const ObjectDecl &other );
 	virtual ~ObjectDecl();
@@ -89,5 +94,5 @@
 	virtual ObjectDecl *clone() const { return new ObjectDecl( *this ); }
 	virtual void accept( Visitor &v ) { v.visit( this ); }
-	virtual ObjectDecl *acceptMutator( Mutator &m ) { return m.mutate( this ); }
+	virtual DeclarationWithType *acceptMutator( Mutator &m ) { return m.mutate( this ); }
 	virtual void print( std::ostream &os, int indent = 0 ) const;
 	virtual void printShort( std::ostream &os, int indent = 0 ) const;
@@ -112,6 +117,4 @@
 	CompoundStmt *get_statements() const { return statements; }
 	void set_statements( CompoundStmt *newValue ) { statements = newValue; }
-	bool get_isInline() const { return isInline; }
-	bool get_isNoreturn() const { return isNoreturn; }
 	std::list< std::string >& get_oldIdents() { return oldIdents; }
 	std::list< Declaration* >& get_oldDecls() { return oldDecls; }
@@ -125,5 +128,4 @@
 	FunctionType *type;
 	CompoundStmt *statements;
-	bool isInline, isNoreturn;
 	std::list< std::string > oldIdents;
 	std::list< Declaration* > oldDecls;
Index: src/SynTree/FunctionDecl.cc
===================================================================
--- src/SynTree/FunctionDecl.cc	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/SynTree/FunctionDecl.cc	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -10,6 +10,6 @@
 // Created On       : Mon May 18 07:44:20 2015
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Sat Jun 13 09:10:32 2015
-// Update Count     : 16
+// Last Modified On : Mon Jul 13 18:11:44 2015
+// Update Count     : 19
 //
 
@@ -22,5 +22,7 @@
 
 FunctionDecl::FunctionDecl( const std::string &name, DeclarationNode::StorageClass sc, LinkageSpec::Type linkage, FunctionType *type, CompoundStmt *statements, bool isInline, bool isNoreturn )
-		: Parent( name, sc, linkage ), type( type ), statements( statements ), isInline( isInline ), isNoreturn( isNoreturn ) {
+		: Parent( name, sc, linkage ), type( type ), statements( statements ) {
+	set_isInline( isInline );
+	set_isNoreturn( isNoreturn );
 	// this is a brazen hack to force the function "main" to have C linkage
 	if ( name == "main" ) {
@@ -30,5 +32,5 @@
 
 FunctionDecl::FunctionDecl( const FunctionDecl &other )
-	: Parent( other ), type( maybeClone( other.type ) ), statements( maybeClone( other.statements ) ), isInline( other.isInline ), isNoreturn( other.isNoreturn ) {
+	: Parent( other ), type( maybeClone( other.type ) ), statements( maybeClone( other.statements ) ) {
 }
 
@@ -57,8 +59,8 @@
 		os << LinkageSpec::toString( get_linkage() ) << " ";
 	} // if
-	if ( isInline ) {
+	if ( get_isInline() ) {
 		os << "inline ";
 	} // if
-	if ( isNoreturn ) {
+	if ( get_isNoreturn() ) {
 		os << "_Noreturn ";
 	} // if
@@ -96,8 +98,8 @@
 		os << get_name() << ": ";
 	} // if
-	if ( isInline ) {
+	if ( get_isInline() ) {
 		os << "inline ";
 	} // if
-	if ( isNoreturn ) {
+	if ( get_isNoreturn() ) {
 		os << "_Noreturn ";
 	} // if
Index: src/SynTree/Mutator.cc
===================================================================
--- src/SynTree/Mutator.cc	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/SynTree/Mutator.cc	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -10,6 +10,6 @@
 // Created On       : Mon May 18 07:44:20 2015
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Mon May 18 10:10:46 2015
-// Update Count     : 1
+// Last Modified On : Thu Jul 16 16:10:54 2015
+// Update Count     : 3
 //
 
@@ -28,5 +28,5 @@
 Mutator::~Mutator() {}
 
-ObjectDecl *Mutator::mutate( ObjectDecl *objectDecl ) {
+DeclarationWithType *Mutator::mutate( ObjectDecl *objectDecl ) {
 	objectDecl->set_type( maybeMutate( objectDecl->get_type(), *this ) );
 	objectDecl->set_init( maybeMutate( objectDecl->get_init(), *this ) );
@@ -109,5 +109,5 @@
 
 Statement *Mutator::mutate( ForStmt *forStmt ) {
-	forStmt->set_initialization( maybeMutate( forStmt->get_initialization(), *this ) );
+	mutateAll( forStmt->get_initialization(), *this );
 	forStmt->set_condition( maybeMutate( forStmt->get_condition(), *this ) );
 	forStmt->set_increment( maybeMutate( forStmt->get_increment(), *this ) );
Index: src/SynTree/Mutator.h
===================================================================
--- src/SynTree/Mutator.h	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/SynTree/Mutator.h	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -9,7 +9,7 @@
 // Author           : Richard C. Bilson
 // Created On       : Mon May 18 07:44:20 2015
-// Last Modified By : Rob Schluntz
-// Last Modified On : Fri May 29 16:34:08 2015
-// Update Count     : 4
+// Last Modified By : Peter A. Buhr
+// Last Modified On : Mon Jul 13 18:14:47 2015
+// Update Count     : 5
 //
 #include <cassert>
@@ -26,5 +26,5 @@
 	virtual ~Mutator();
   public:
-	virtual ObjectDecl* mutate( ObjectDecl *objectDecl );
+	virtual DeclarationWithType* mutate( ObjectDecl *objectDecl );
 	virtual DeclarationWithType* mutate( FunctionDecl *functionDecl );
 	virtual Declaration* mutate( StructDecl *aggregateDecl );
Index: src/SynTree/ObjectDecl.cc
===================================================================
--- src/SynTree/ObjectDecl.cc	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/SynTree/ObjectDecl.cc	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -10,6 +10,6 @@
 // Created On       : Mon May 18 07:44:20 2015
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Sat Jun 13 08:10:16 2015
-// Update Count     : 15
+// Last Modified On : Mon Jul 13 18:08:27 2015
+// Update Count     : 16
 //
 
@@ -20,6 +20,8 @@
 #include "utility.h"
 
-ObjectDecl::ObjectDecl( const std::string &name, DeclarationNode::StorageClass sc, LinkageSpec::Type linkage, Expression *bitfieldWidth, Type *type, Initializer *init )
+ObjectDecl::ObjectDecl( const std::string &name, DeclarationNode::StorageClass sc, LinkageSpec::Type linkage, Expression *bitfieldWidth, Type *type, Initializer *init, bool isInline, bool isNoreturn )
 	: Parent( name, sc, linkage ), type( type ), init( init ), bitfieldWidth( bitfieldWidth ) {
+	set_isInline( isInline );
+	set_isNoreturn( isNoreturn );
 }
 
Index: src/SynTree/Statement.cc
===================================================================
--- src/SynTree/Statement.cc	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/SynTree/Statement.cc	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -9,7 +9,7 @@
 // Author           : Richard C. Bilson
 // Created On       : Mon May 18 07:44:20 2015
-// Last Modified By : Peter A. Buhr
-// Last Modified On : Mon Jun 29 17:37:10 2015
-// Update Count     : 22
+// Last Modified By : Rob Schluntz
+// Last Modified On : Wed Jul 15 14:57:40 2015
+// Update Count     : 27
 //
 
@@ -192,10 +192,10 @@
 }
 
-ForStmt::ForStmt( std::list<Label> labels, Statement *initialization_, Expression *condition_, Expression *increment_, Statement *body_ ):
+ForStmt::ForStmt( std::list<Label> labels, std::list<Statement *> initialization_, Expression *condition_, Expression *increment_, Statement *body_ ):
 	Statement( labels ), initialization( initialization_ ), condition( condition_ ), increment( increment_ ), body( body_ ) {
 }
 
 ForStmt::~ForStmt() {
-	delete initialization;
+	deleteAll( initialization );
 	delete condition;
 	delete increment;
@@ -213,6 +213,7 @@
 
 	os << string( indent + 2, ' ' ) << "initialization: \n"; 
-	if ( initialization != 0 )
-		initialization->print( os, indent + 4 );
+	for ( std::list<Statement *>::const_iterator it = initialization.begin(); it != initialization.end(); ++it ) {
+		(*it)->print( os, indent + 4 );
+	}
 
 	os << "\n" << string( indent + 2, ' ' ) << "condition: \n"; 
Index: src/SynTree/Statement.h
===================================================================
--- src/SynTree/Statement.h	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/SynTree/Statement.h	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -9,7 +9,7 @@
 // Author           : Richard C. Bilson
 // Created On       : Mon May 18 07:44:20 2015
-// Last Modified By : Peter A. Buhr
-// Last Modified On : Tue Jun 23 11:44:27 2015
-// Update Count     : 20
+// Last Modified By : Rob Schluntz
+// Last Modified On : Tue Jul 14 12:14:54 2015
+// Update Count     : 24
 //
 
@@ -199,10 +199,10 @@
 class ForStmt : public Statement {
   public:
-	ForStmt( std::list<Label> labels, Statement *initialization = 0,
+	ForStmt( std::list<Label> labels, std::list<Statement *> initialization,
 	     Expression *condition = 0, Expression *increment = 0, Statement *body = 0 );
 	virtual ~ForStmt();
 
-	Statement *get_initialization() { return initialization; }
-	void set_initialization( Statement *newValue ) { initialization = newValue; }
+	std::list<Statement *> &get_initialization() { return initialization; }
+	void set_initialization( std::list<Statement *> newValue ) { initialization = newValue; }
 	Expression *get_condition() { return condition; }
 	void set_condition( Expression *newValue ) { condition = newValue; }
@@ -217,5 +217,5 @@
 	virtual void print( std::ostream &os, int indent = 0 ) const;
   private:
-	Statement *initialization;
+	std::list<Statement *> initialization;
 	Expression *condition;
 	Expression *increment;
Index: src/SynTree/Type.cc
===================================================================
--- src/SynTree/Type.cc	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/SynTree/Type.cc	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -10,6 +10,6 @@
 // Created On       : Mon May 18 07:44:20 2015
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Tue May 19 16:52:27 2015
-// Update Count     : 2
+// Last Modified On : Thu Jul  9 16:45:13 2015
+// Update Count     : 3
 //
 
@@ -75,4 +75,7 @@
 		os << "_Atomic ";
 	} // if
+	if ( tq.isAttribute ) {
+		os << "__attribute(( )) ";
+	} // if
 }
 
Index: src/SynTree/Type.h
===================================================================
--- src/SynTree/Type.h	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/SynTree/Type.h	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -10,6 +10,6 @@
 // Created On       : Mon May 18 07:44:20 2015
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Fri Jun 26 16:47:54 2015
-// Update Count     : 13
+// Last Modified On : Thu Jul  9 16:46:15 2015
+// Update Count     : 14
 //
 
@@ -25,5 +25,5 @@
 	struct Qualifiers {  
 		Qualifiers(): isConst( false ), isVolatile( false ), isRestrict( false ), isLvalue( false ), isAtomic( false ), isAttribute( false ) {}
-		Qualifiers( bool isConst, bool isVolatile, bool isRestrict, bool isLvalue, bool isAtomic, bool isAttribute): isConst( isConst ), isVolatile( isVolatile ), isRestrict( isRestrict ), isLvalue( isLvalue ), isAtomic( isAtomic ), isAttribute( isAttribute ) {}
+		Qualifiers( bool isConst, bool isVolatile, bool isRestrict, bool isLvalue, bool isAtomic, bool isAttribute ): isConst( isConst ), isVolatile( isVolatile ), isRestrict( isRestrict ), isLvalue( isLvalue ), isAtomic( isAtomic ), isAttribute( isAttribute ) {}
 	
 		Qualifiers &operator+=( const Qualifiers &other );
Index: src/SynTree/Visitor.cc
===================================================================
--- src/SynTree/Visitor.cc	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/SynTree/Visitor.cc	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -9,7 +9,7 @@
 // Author           : Richard C. Bilson
 // Created On       : Mon May 18 07:44:20 2015
-// Last Modified By : Peter A. Buhr
-// Last Modified On : Mon May 18 11:14:51 2015
-// Update Count     : 2
+// Last Modified By : Rob Schluntz
+// Last Modified On : Tue Jul 14 12:31:03 2015
+// Update Count     : 3
 //
 
@@ -94,6 +94,5 @@
 
 void Visitor::visit( ForStmt *forStmt ) {
-	// ForStmt still needs to be fixed
-	maybeAccept( forStmt->get_initialization(), *this );
+	acceptAll( forStmt->get_initialization(), *this );
 	maybeAccept( forStmt->get_condition(), *this );
 	maybeAccept( forStmt->get_increment(), *this );
Index: src/driver/cc1.cc
===================================================================
--- src/driver/cc1.cc	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/driver/cc1.cc	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -10,6 +10,6 @@
 // Created On       : Fri Aug 26 14:23:51 2005
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Sat May 30 08:58:29 2015
-// Update Count     : 51
+// Last Modified On : Thu Jul 16 17:09:14 2015
+// Update Count     : 54
 //
 
@@ -319,7 +319,4 @@
 		uargs[0] = ( *new string( bprefix + "/cfa-cpp" ) ).c_str();
 
-		uargs[nuargs] = "-p";
-		nuargs += 1;
-
 		uargs[nuargs] = tmpname;
 		nuargs += 1;
Index: src/driver/cfa.cc
===================================================================
--- src/driver/cfa.cc	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/driver/cfa.cc	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -10,6 +10,6 @@
 // Created On       : Tue Aug 20 13:44:49 2002
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Tue Jun 23 17:47:03 2015
-// Update Count     : 119
+// Last Modified On : Thu Jul 16 17:09:23 2015
+// Update Count     : 124
 //
 
@@ -52,4 +52,5 @@
 	string Version( VERSION );							// current version number from CONFIG
 	string Major( "0" ), Minor( "0" ), Patch( "0" );	// default version numbers
+
 	int posn1 = Version.find( "." );					// find the divider between major and minor version numbers
 	if ( posn1 == -1 ) {								// not there ?
@@ -256,7 +257,9 @@
 	// add the correct set of flags based on the type of compile this is
 
-	args[nargs] = ( *new string( string("-D__CFA_MAJOR__=") + Major ) ).c_str();
+	args[nargs] = ( *new string( string("-D__CFA__=") + Major ) ).c_str();
 	nargs += 1;
 	args[nargs] = ( *new string( string("-D__CFA_MINOR__=") + Minor ) ).c_str();
+	nargs += 1;
+	args[nargs] = ( *new string( string("-D__CFA_PATCHLEVEL__=") + Patch ) ).c_str();
 	nargs += 1;
 
Index: src/main.cc
===================================================================
--- src/main.cc	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/main.cc	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -10,6 +10,6 @@
 // Created On       : Fri May 15 23:12:02 2015
 // Last Modified By : Rob Schluntz
-// Last Modified On : Mon Jul 06 15:01:26 2015
-// Update Count     : 79
+// Last Modified On : Wed Jul 15 16:45:24 2015
+// Update Count     : 145
 //
 
@@ -54,5 +54,6 @@
 	if ( errorp ) std::cerr << x << std::endl;
 
-void parse( FILE * input, LinkageSpec::Type t, bool shouldExit = false );
+static void parse( FILE * input, LinkageSpec::Type t, bool shouldExit = false );
+static void dump( std::list< Declaration * > & translationUnit );
 
 bool
@@ -64,5 +65,5 @@
 	libcfap = false,
 	nopreludep = false,
-	protop = false,
+	noprotop = false,
 	parsep = false,
 	resolvep = false,									// used in AlternativeFinder
@@ -81,7 +82,7 @@
 	{ "grammar", no_argument, 0, Grammar },
 	{ "libcfa", no_argument, 0, LibCFA },
-	{ "nopreamble", no_argument, 0, Nopreamble },
+	{ "no-preamble", no_argument, 0, Nopreamble },
 	{ "parse", no_argument, 0, Parse },
-	{ "prototypes", no_argument, 0, Prototypes },
+	{ "no-prototypes", no_argument, 0, Prototypes },
 	{ "resolver", no_argument, 0, Resolver },
 	{ "symbol", no_argument, 0, Symbol },
@@ -131,5 +132,5 @@
 		  case Prototypes:
 		  case 'p':										// generate prototypes for preamble functions
-			protop = true;
+			noprotop = true;
 			break;
 		  case Parse:
@@ -221,5 +222,5 @@
 		Parser::get_parser().freeTree();
 		if ( astp ) {
-			printAll( translationUnit, std::cout );
+			dump( translationUnit );
 			return 0;
 		} // if
@@ -242,5 +243,5 @@
 
 		if ( validp ) {
-			printAll( translationUnit, std::cout );
+			dump( translationUnit );
 			return 0;
 		} // if
@@ -252,5 +253,4 @@
 
 		if ( libcfap ) {
-			protop = true;
 			// generate the bodies of cfa library functions
 			LibCfa::makeLibCfa( translationUnit );
@@ -258,5 +258,5 @@
 
 		if ( bresolvep ) {
-			printAll( translationUnit, std::cout );
+			dump( translationUnit );
 			return 0;
 		} // if
@@ -265,5 +265,5 @@
 		ResolvExpr::resolve( translationUnit );
 		if ( exprp ) {
-			printAll( translationUnit, std::cout );
+			dump( translationUnit );
 		}
 
@@ -279,9 +279,9 @@
 		// print tree right before code generation
 		if ( codegenp ) {
-			printAll( translationUnit, std::cout );
-			return 0;
-		} // if
-
-		CodeGen::generate( translationUnit, *output, true ); //protop );
+			dump( translationUnit );
+			return 0;
+		} // if
+
+		CodeGen::generate( translationUnit, *output, ! noprotop );
 
 		if ( output != &std::cout ) {
@@ -290,5 +290,5 @@
 	} catch ( SemanticError &e ) {
 		if ( errorp ) {
-			printAll( translationUnit, std::cerr );
+			dump( translationUnit );
 		}
 		e.print( std::cerr );
@@ -315,5 +315,5 @@
 } // main
 
-void parse( FILE * input, LinkageSpec::Type linkage, bool shouldExit ) {
+static void parse( FILE * input, LinkageSpec::Type linkage, bool shouldExit ) {
 	Parser::get_parser().set_linkage( linkage );
 	Parser::get_parser().parse( input );
@@ -325,4 +325,21 @@
 }
 
+static bool notPrelude( Declaration * decl ) {
+	return ! LinkageSpec::isBuiltin( decl->get_linkage() );
+}
+
+static void dump( std::list< Declaration * > & translationUnit ) {
+	std::list< Declaration * > decls;
+	if ( noprotop ) {
+		filter( translationUnit.begin(), translationUnit.end(), 
+				std::back_inserter( decls ), notPrelude );
+	} else {
+		decls = translationUnit;
+	}
+
+	printAll( decls, std::cout );
+}
+
+
 // Local Variables: //
 // tab-width: 4 //
